// Gary Yngve 10/10/2005

public interface MineStrategy {

    // the user may assume the following:
    // UNKNOWN is 0 (no determination can be made)
    // MARK and EXPLORE have opposite signs
    // MARK and EXPLORE are 100% mark / explore, though their numerical
    // values are not to be relied on
    // a value between UNKNOWN and MARK means more likely to have a mine
    // than not, and a value between UNKNOWN and EXPLORE is more likely
    // to be safe than not.  Similarly, MARK/2 is more likely to have a
    // mine than MARK/3

    public static final int UNKNOWN = 0; // must remain 0
    public static final int EXPLORE = -100;
    public static final int MARK = 100; // must have MARK*EXPLORE < 0

// proposes a strategy for (i,j) on the MineBoard mb
// ALL DEDUCTIONS ASSUME THAT A MARKED SQUARE IS A MINE.

    int decide(MineBoard mb, int i, int j);

}
