// Gary Yngve 10/10/2005
// If there's a zero adjacent to the current square, it's safe to explore,
// otherwise no decision can be made.

public class ZerosMineStrategy implements MineStrategy {

    public static final ZerosMineStrategy INSTANCE = new ZerosMineStrategy();

    private ZerosMineStrategy() {} // singleton

    public int decide(MineBoard mb, int i, int j) {
        for(int m = -1; m <= 1; m++)
            for(int n = -1; n <= 1; n++) {
                if (mb.askable(i+m,j+n) && mb.ask(i+m,j+n) == 0)
                    return MineStrategy.EXPLORE;
            }
        return MineStrategy.UNKNOWN;
    }

}
